import random
import zlib

def tinycode(key, text, reverse=False):
    rand = random.Random(key).randrange
    if not reverse:
        text = zlib.compress(text)
    text = ''.join([chr(ord(elem)^rand(256)) for elem in text])
    if reverse:
        text = zlib.decompress(text)
    return text

if __name__ == "__main__":

    def strToHex(aString):
        hexlist = ["%02X " % ord(x) for x in aString]
        return ''.join(hexlist)

    keyStr = "This is a key"
    testStr = "which witch had which witches wrist watch"

    print "String:", testStr
    testStr = tinycode(keyStr, testStr)
    print "Encrypted string:", testStr
    print "Hex    : ", strToHex(testStr)
    testStr = tinycode(keyStr, testStr, reverse=True)
    print "Decrypted string:", testStr
