# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk

import ogzConfig
import ogzFrameCalendars
import ogzFrameCalendars2
import ogzFrameTasks
import ogzFrameEvents
import ogzFramePreview
import ogzFrameCategories
import ogzPostIt
import ogzStickiesPlugin
from ogzEditTask import ogzDialogTask
from ogzDialogCalendar import ogzDialogCalendar
from ogzBigCalendar import ogzBigCalendar
from ogzWeekCalendar import ogzWeekCalendar
from ogzMonthCalendar import ogzMonthCalendar
from ogzDialogDel import ogzDialogDel
from ogzDialogCategories import ogzDialogCategories
from ogzDialogConfig import ogzDialogConfig
from icalendar import Todo, vDatetime
from ogzUIDGenerator import UIDGenerator
from datetime  import datetime
import thread

class ogzBase:
    def __init__(self):

        self.oConf = ogzConfig.ogzConfig(self)
    
        #gtk.rc_set_default_files("themes\e17default\gtk-2.0\gtkrc")
        #gtk.rc_parse("themes\e17default\gtk-2.0\gtkrc")
        #print "theme parse"
        
        self.statusIcon = gtk.StatusIcon()
        self.statusIcon.set_from_stock(gtk.STOCK_INFO)
        self.statusIcon.set_tooltip("NGCal")

        self.window_viewed = True


        self.win = gtk.Window()
        self.win.set_role("NGCal 0.10")
        self.win.set_title("NGCal 0.10")
        self.win.set_icon_from_file("appointment-new.png")
        if self.oConf.miscOptions.has_key("winSize"):
            c = self.oConf.miscOptions["winSize"]
            h,w = c.strip('()').split(',')
            self.win.resize(int(h), int(w))
           # self.win.set_size_request(int(h), int(w))
        else: 
            self.win.set_default_size(850,630)
        #self.win.set_size_request(850,630)
        
        uimanager = gtk.UIManager()
        uimanager.add_ui_from_file("ogzMenus.ui")
        
        
        actionGroup = gtk.ActionGroup('UIManagerExample')

        actionGroup.add_actions([('Quit', gtk.STOCK_QUIT, '_Quit', None,'Quit the Program', self.winClose),
                                 ('Add_new_calendar', gtk.STOCK_ADD, '_Add new calendar', None,None, self.add_new_calendar),
                                 ('Import/open existing calendar', gtk.STOCK_OPEN, '_Open existing calendar', None, None, self.open_existing_calendar),
                                 ('Change calendar name', gtk.STOCK_EDIT, '_Change calendar name', None,None, self.edit_selected_calendar ),
                                 ('Save calendars', gtk.STOCK_SAVE, '_Save calendars', None,None, self.save_all_calendars ),
                                 ('Application', None, '_Application'),
                                 ('File', None, '_File'),
                                 ('Task', None, '_Task'),
                                 ('Event', None, '_Event'),
                                 ('View', None, '_View'),
                                 ('Settings', None ,'_Settings'),
                                 ('Add new task', gtk.STOCK_ADD, '_Add new task', None,None, self.add_new_task),
                                 ('Add new event', gtk.STOCK_ADD, '_Add new event', None, None, self.add_new_event),
                                 ('Edit task', gtk.STOCK_EDIT, '_Edit selected task', None,None, self.edit_selected_task),
                                 ('Edit event', gtk.STOCK_EDIT, 'Edit selected event', None, None, self.edit_selected_event),
                                 ('Delete task(s)', gtk.STOCK_DELETE, '_Delete selected task(s)', None,None, self.delete_selected_task),
                                 ('Delete event(s)', gtk.STOCK_DELETE, '_Delete selected event(s)', None, None, None),
                                 ('Preferences', gtk.STOCK_PREFERENCES, '_Preferences',None,None, self.edit_config),
                                 ('Make Post-it', gtk.STOCK_JUSTIFY_CENTER, '_Make Post-it',None,None, self.make_postit),          
                                 ('Edit categories', gtk.STOCK_EDIT, '_Edit categories', None, None,self.edit_categories),                                 
                                 ('Help', None, '_Help'),
                                 ('About', gtk.STOCK_ABOUT, '_About odjizzy', None, None, self.about_dialog),
                                 ('Website', gtk.STOCK_NETWORK, '_Website', None, None, self.website_dialog)
                                ])
        actionGroup.add_radio_actions([('Big Calendar', None, '_Big Calendar', None,None, 0),
                                       ('Tasks List', None, '_Tasks List', None,None, 1),
                                       ('Events List', None, '_Events List', None,None, 2),
                                       ('Journal', None, '_Journal', None,None, 3),
                                       ], 0, None)    
                                       
        uimanager.insert_action_group(actionGroup, 0)
        
        
        wVBox = gtk.VBox(homogeneous=False, spacing=0)
        vBoxLeft = gtk.VBox(homogeneous=False, spacing=0)
        self.wHPan = gtk.HPaned()
        self.wVPanLeft = gtk.VPaned()
        self.wVPanRight = gtk.VPaned()
        wStatusBar = gtk.Statusbar()
        
        wCalendar = gtk.Calendar()
        #wVPanLeft.add1(wCalendar)
        
        
        
        self.frameCategories = ogzFrameCategories.ogzFrameCategories(self)
        self.wVPanLeft.add1(self.frameCategories.frame)
        
        self.frameCalendars = ogzFrameCalendars2.ogzFrameCalendars(self.oConf.calendars, self)
        self.wVPanLeft.add2(self.frameCalendars.frame)

        self.frameTasks = ogzFrameTasks.ogzFrameTasks(self.oConf.calendars, self)
        self.wVPanRight.add1(self.frameTasks.frame)
        
        self.framePreview = ogzFramePreview.ogzFramePreview(self)
        self.wVPanRight.add2(self.framePreview.frame)
        
        
        # other frames
        self.frameBigCalendar = ogzBigCalendar(self)
        self.frameEvents = ogzFrameEvents.ogzFrameEvents(self.oConf.calendars, self)
        self.frameWeekCalendar = ogzWeekCalendar(self)
        self.frameMonthCalendar = ogzMonthCalendar(self)
        
        vBoxLeft.pack_start(child=wCalendar ,expand=False, fill=True, padding=0)
        vBoxLeft.pack_start(child=self.wVPanLeft ,expand=True, fill=True, padding=0)
        
        
        self.notebook1 = gtk.Notebook()
        self.notebook1.append_page(vBoxLeft, gtk.Label("Prefs"))
        
        self.wHPan.add1(self.notebook1)
        
        #self.wHPan.add1(vBoxLeft)
        
        #self.wHPan.add2(self.wVPanRight)
        self.notebook2 = gtk.Notebook()
        
        self.notebook2.append_page(self.wVPanRight, gtk.Label("Tasks"))
        #self.notebook2.append_page(self.frameEvents.frame, gtk.Label("Events"))
        # BigCalendar et WeekCalendar sont+ trop gros (hauteur = 1000)
        #self.notebook2.append_page(self.frameBigCalendar.frame, gtk.Label("Day View"))
        #self.notebook2.append_page(self.frameWeekCalendar.frame, gtk.Label("Week View"))
        #self.notebook2.append_page(self.frameMonthCalendar.frame, gtk.Label("Month View"))
       ## self.notebook2.append_page(vBoxLeft, gtk.Label("Prefs"))
        
         
                
        self.wHPan.add2(self.notebook2)
#        self.wHPan.set_position(200)
#        wVPanLeft.set_position(100)
#        self.wVPanRight.set_position(300)

        if self.oConf.miscOptions.has_key("wHPanPos"):
            p = int(self.oConf.miscOptions["wHPanPos"])
            self.wHPan.set_position(p)
        else:
            self.wHPan.set_position(200)
        if self.oConf.miscOptions.has_key("wVPanLeftPos"):
            p = int(self.oConf.miscOptions["wVPanLeftPos"])
            self.wVPanLeft.set_position(p)
        else:
            self.wVPanLeft.set_position(100)
            
        if self.oConf.miscOptions.has_key("wVPanRightPos"):
            p = int(self.oConf.miscOptions["wVPanRightPos"])
            self.wVPanRight.set_position(p)
        else:            
            self.wVPanRight.set_position(100)



        
        wVBox = gtk.VBox(homogeneous=False, spacing=0)
        wVBox.pack_start(child=uimanager.get_widget("/MenuBar") ,expand=False, fill=True, padding=0)
        wVBox.pack_start(child=self.wHPan ,expand=True, fill=True, padding=0)
        wVBox.pack_start(child=wStatusBar ,expand=False, fill=True, padding=0)
        
   
        #self.notebook.prev_page()
        
        
        self.win.add(wVBox)
        
        self.win.connect("destroy",self.winClose)
        self.win.connect("size-allocate", self.winSizeAllocate)
        self.win.connect("configure_event", self.configEvent)

        self.statusIcon.connect("popup-menu", self.popmenustatus)

        if self.oConf.miscOptions.has_key("tabSelected"):
            t = int(self.oConf.miscOptions["tabSelected"])
        else:
            t = 0
        
        self.win.show_all()
        
        self.oStickPlug = ogzStickiesPlugin.ogzStickiesPlugin()
        self.threadId = thread.start_new_thread(self.oStickPlug.init_server,(self,""))
        
        # PARCOURIR LES TODOS:
        for ocal in self.oConf.calendars.values():
            if ocal.selected == True:
                for todo in ocal.cal.walk('VTODO'):
                    if todo.has_key("X-OGZP"):
                        p = ogzPostIt.ogzPostIt(self, todo, ocal)
 
        self.notebook2.set_current_page(t)
        self.notebook2.show()
        print "tab=",t
        self.notebook2.emit("select-page" , False)
  

    def winSizeAllocate(self, widget, rect):
#        self.oConf.setOption("winSize", self.win.get_size())
        self.oConf.setOption("wHPanPos", self.wHPan.get_position())
        self.oConf.setOption("wVPanLeftPos", self.wVPanLeft.get_position())
        self.oConf.setOption("wVPanRightPos", self.wVPanRight.get_position())
        self.oConf.setOption("tabSelected", self.notebook2.get_current_page())  
        print "," , self.notebook2.get_current_page()
        
    def configEvent(self, widget, allocation):
        self.win.width, self.win.height = self.win.get_size()
        self.oConf.setOption("winSize", self.win.get_size())      
        #print "."       

    def winClose(self, widget, data=None):
        self.oConf.writeConfOnDisk()
        if self.oConf.autoSaveExit:
           self.save_all_calendars("")
        else:
           self.ask_for_saving()
        del self.statusIcon
        print self.win.width, self.win.height
        gtk.main_quit() 
        
        
    def redisplay_selected_calendars(self):
        self.frameTasks.display()
    
    def redisplay_categories(self):
        self.frameCategories.display()
    
    def preview_selected_element(self, element):
        self.framePreview.preview(element)
    
    def edit_selected_calendar(self, data):
        cal = self.frameCalendars.get_selected()
        dialog = ogzDialogCalendar(cal, "edit", self.oConf)
        dialog.run()
        self.frameCalendars.display()
        
    def save_all_calendars(self, data):
        for ocal in self.oConf.calendars.values():
            self.oConf.writeCalendarOnDisk(ocal)                
    
    def add_new_calendar(self, data):
        print "+", data
        newCal = self.oConf.createNewTempCalendar()
        dialog = ogzDialogCalendar(newCal, "new", self.oConf)
        dialog.run()
        self.frameCalendars.display()

    def open_existing_calendar(self, data):
        newCal = self.oConf.createNewTempCalendar()
        dialog = ogzDialogCalendar(newCal, "open", self.oConf)
        dialog.run()
        self.frameCalendars.display()
    
    def add_new_task(self,data):
        task = Todo()
        task['SUMMARY'] = "Nouvelle_tache"
        task['CATEGORIES'] = "Non classe"
        task['PRIORITY'] = "5"
        #task['DTSTART'] = vDatetime(datetime.today()).ical()
        #task['DUE'] = vDatetime(datetime.today()).ical()
        task['CREATED'] = vDatetime(datetime.today()).ical()
        task['DTSTAMP'] = vDatetime(datetime.today()).ical()
        task['DESCRIPTION'] = ""
        task['STATUS'] = "NEEDS-ACTION"
        task['PERCENT-COMPLETE'] = 0
        
        g = UIDGenerator()
        uid = g.uid()
        task['uid'] = uid.ical()
        
        ocal = self.oConf.calendars.values()[0]
        for c in self.oConf.calendars.values():
            if c.selected == True:
                ocal = c
                break
        ocal.cal.add_component(task)
        
        #self.iter = self.lst_tasks.append([ocal.nbTasks, task['SUMMARY'], self.dCalendar.keys()[0]])
        #self.tvw_tasks.set_cursor(self.lst_tasks.get_path(self.iter))
        self.frameTasks.append(task, ocal)
        #self.selectedCal = ocal
    
        dialog = ogzDialogTask(self, task, ocal)
        print "+", data
        
    def add_new_event(self, data):
        event = Event()
        event['CREATED'] = vDatetime(datetime.today()).ical()
        event['DTSTAMP'] = vDatetime(datetime.today()).ical()
        event ['DESCRIPTION'] = ""
        g = UIDGenerator()
        uid = g.uid()
        event['uid'] = uid.ical()

        print "+", data        
        
    def edit_selected_task(self, data):
        task, cal = self.frameTasks.get_selected()
        dialog = ogzDialogTask(self, task, cal)
        
    def edit_selected_event(self, data):
        print "=", data    

    def delete_selected_task(self, data):
        task, cal = self.frameTasks.get_selected()
        dialog = ogzDialogDel(self, task, cal)
    
    def edit_categories(self, data):
        dialog = ogzDialogCategories(self)
    
    def message(self, mess):
        dialog = gtk.Dialog("", self.win, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                     (gtk.STOCK_OK, gtk.RESPONSE_OK))
        dialog.set_default_size(340,160)
        label = gtk.Label()
        label.set_text(mess)
        dialog.vbox.pack_start(child=label ,expand=False, fill=True, padding=8)
        dialog.show_all()
        lo=dialog.run()
        print "apres"
        dialog.emit("close")
        dialog.emit("destroy")
    
    def ask_for_saving(self):
        dialog = gtk.Dialog("", self.win, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                     (gtk.STOCK_YES, gtk.RESPONSE_YES,
                      gtk.STOCK_NO, gtk.RESPONSE_NO))
        dialog.set_default_size(340,160)
        label = gtk.Label()
        label.set_text("Save changes in calendars ?")
        dialog.vbox.pack_start(child=label ,expand=False, fill=True, padding=8)
        dialog.show_all()
        response=dialog.run()
        if response == gtk.RESPONSE_YES:
            self.save_all_calendars("")
        dialog.destroy()        
    
    def edit_config(self, data):
        dialog = ogzDialogConfig(self.oConf)
        dialog.run()
    
    def about_dialog(self, data):
        dialog = gtk.AboutDialog()
        dialog.set_name("NGCal")
        dialog.set_version("0.10")
        dialog.set_authors(["Michel Cailhol"])
        dialog.set_website("micosphere@free.fr")
        dialog.set_logo(gtk.gdk.pixbuf_new_from_file("appointment-new.png"))
        dialog.show_all()
        dialog.run()
        dialog.destroy()
        
    def website_dialog(self, data):
        builder = gtk.Builder()
        builder.add_from_file("dialogs.ui")
        dialog = builder.get_object("website_dialog")
        dialog.show_all()
        dialog.run()
        dialog.destroy()
            
       
    def make_postit(self,data):
        task, cal = self.frameTasks.get_selected()
        p = ogzPostIt.ogzPostIt(self, task, cal)    

    def netStickiesPostit(self, width, color, text,exp):
        import operator
        #print "net:",text
        #print "net:",color
        task = Todo()
        task['SUMMARY'] = exp
        print text
        task['DESCRIPTION'] = text
        color3 = gtk.gdk.Color(int(color[0]) * 257, int(color[1]) * 257, int(color[2]) * 257,0)
        task['X-OGZPCOLOR'] = color3.to_string()
        task['X-OGZPWIDTH'] = str(width)
        task['STATUS'] = "OPEN"
        task['X-OGZPKEEPABOVE'] = "True"
        ocal = self.oConf.calendars.values()[0]
        for c in self.oConf.calendars.values():
            if c.selected == True:
                ocal = c
                break
        ocal.cal.add_component(task)
        p = ogzPostIt.ogzPostIt(self, task, ocal)
        #p.textview.modify_base(gtk.STATE_NORMAL, gtk.gdk.Color(int(color[0]) * 257, int(color[1]) * 257, int(color[2]) * 257, 0))
        

    def popmenustatus(self, sticon, button, data):
        menu = gtk.Menu()
        item = gtk.CheckMenuItem("View")
        item.connect("activate", self.toggle_viewed)
        item.set_active(self.window_viewed)
        self.toggle_viewed(item)
        menu.append(item)
        
        item = gtk.ImageMenuItem(gtk.STOCK_QUIT)
        item.connect("activate", self.winClose)
        menu.append(item)
        
        menu.show_all()
        menu.popup(None,None,None,button,data)
    
    def toggle_viewed(self, data):
        if data.get_active():
            self.win.show_all()
            self.window_viewed = True
        else:
            self.win.hide_all()
            self.window_viewed = False
    
    def go(self):
        gtk.main()

        
        
        
        
        

        
