# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk
import os
from ogzCalendar import ogzCalendar

class ogzDialogCalendar:
    def __init__(self, calendar, mode, oConf):
        self.calendar = calendar
        self.mode = mode # new or edit
        self.oConf = oConf
        self.dialog = gtk.Dialog("Calendar",None,gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                     (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                        gtk.STOCK_OK, gtk.RESPONSE_OK
                      ))
        self.dialog.set_default_size(440,160)
        
                      
        labelName = gtk.Label()
        labelName.set_text("Name")
        self.entryName = gtk.Entry()
        self.entryName.set_text(self.calendar.name)
        labelFile = gtk.Label()
        labelFile.set_text("File")
        self.entryFile = gtk.Entry()
        self.entryFile.set_text(self.calendar.filename)
        self.btnFile = gtk.Button()
        image = gtk.Image()
        image.set_from_stock(gtk.STOCK_OPEN,4)
        self.btnFile.add(image)
        HBoxName = gtk.HBox()
        HBoxFile = gtk.HBox()
        HBoxName.pack_start(child=labelName, expand=False, fill=True, padding=8)
        HBoxName.pack_start(child=self.entryName, expand=True, fill=True, padding=8)
        HBoxFile.pack_start(child=labelFile, expand=False, fill=True, padding=8)
        HBoxFile.pack_start(child=self.entryFile, expand=True, fill=True, padding=8)
        HBoxFile.pack_start(child=self.btnFile, expand=False, fill=True, padding=8)
        self.dialog.vbox.pack_start(child=HBoxName ,expand=False, fill=False, padding=8)
        self.dialog.vbox.pack_start(child=HBoxFile ,expand=False, fill=False, padding=8)
        
        
        self.btnFile.connect("clicked", self.choose_file)
        if self.mode == "edit":
            self.btnFile.set_sensitive(False)
            self.entryFile.set_sensitive(False)
        
        self.dialog.show_all() 
    def run(self):    
        response = self.dialog.run()
        if response == gtk.RESPONSE_OK:
            self.calendar.name = self.entryName.get_text()
            if self.verify() == "ok" and self.mode != "edit":  # new calendar
                self.calendar.filename = self.entryFile.get_text()
                if self.mode == "new":
                    self.calendar.create(self.calendar.filename)
                self.calendar.load2()
                self.oConf.addCalendar(self.calendar)
        self.dialog.destroy()

    def choose_file(self,data):
        if self.mode == "new":
            dialog = gtk.FileChooserDialog(title="Save",action=gtk.FILE_CHOOSER_ACTION_SAVE,
                                  buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_SAVE,gtk.RESPONSE_OK))
        elif self.mode  == "open":
            dialog = gtk.FileChooserDialog(title="Save",action=gtk.FILE_CHOOSER_ACTION_OPEN,
                                  buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            self.entryFile.set_text(dialog.get_filename())
        elif response == gtk.RESPONSE_CANCEL:
            print 'Closed, no files selected'
        dialog.destroy()
        
    def verify(self):
        fName = self.entryFile.get_text()
        if not os.path.isdir(os.path.dirname(fName)):
            print "Invalid Path"
            return "cancel"
        if self.mode == "open" and not os.path.isfile(fName):
            print "File not found"
            return "cancel"
        else:
            return "ok"
            
