# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk

from ogzCalendar import ogzCalendar

class ogzDialogCategories:
    def __init__(self, obase):
        self.oBase = obase
        self.dialog = gtk.Dialog("Task",None,gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                                   (gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE))
        self.dialog.set_default_size(440,360)
        
        self.listStore = gtk.ListStore(str)

        self.treeView = gtk.TreeView(self.listStore)
       
        cel_text = gtk.CellRendererText()
        col_name = gtk.TreeViewColumn('Name')
        col_name.pack_start(cel_text, False)
        col_name.add_attribute(cel_text, 'markup', 0) 
        self.treeView.append_column(col_name)
        
        hbox = gtk.HBox()
        add_button = gtk.Button(gtk.STOCK_ADD, gtk.STOCK_ADD)
        edit_button = gtk.Button(gtk.STOCK_EDIT, gtk.STOCK_EDIT)
        del_button = gtk.Button(gtk.STOCK_DELETE, gtk.STOCK_DELETE)
        hbox.pack_start(child=del_button,expand=False, fill=False, padding=8)
        hbox.pack_start(child=gtk.VSeparator(),expand=False, fill=False, padding=8)
        hbox.pack_start(child=edit_button,expand=False, fill=False, padding=8)
        hbox.pack_start(child=add_button,expand=False, fill=False, padding=8)
        
        self.dialog.vbox.pack_start(child=self.treeView ,expand=True, fill=True, padding=4)
        self.dialog.vbox.pack_start(child=hbox ,expand=False, fill=False, padding=4)
        
        self.display()
        
        self.treeSelection = self.treeView.get_selection()
        add_button.connect("clicked", self.add_categories)
        edit_button.connect("clicked", self.edit_categories)
        del_button.connect("clicked", self.del_categories)
        self.dialog.show_all() 
        response = self.dialog.run()
        if response == gtk.RESPONSE_OK:
            pass
#            self.oBase.redisplay_selected_calendars()
        self.dialog.destroy()
    
    def display(self):
        self.listStore.clear()
        for cat in self.oBase.oConf.categories.keys():
            self.listStore.append([cat])
    
    def delete_confirm (self):
        pass
            
    def add_categories(self, data):
        dialog = gtk.Dialog("Add Categories",None,gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                                   (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OK, gtk.RESPONSE_OK))
        label = gtk.Label()
        entry = gtk.Entry()
        label.set_text("Name")
        dialog.vbox.pack_start(label,False,True,4)
        dialog.vbox.pack_start(entry,False,True,4)
        dialog.show_all()
        response = dialog.run()
        if response == gtk.RESPONSE_OK and entry.get_text() != "":
            self.oBase.oConf.add_categorie(entry.get_text())
            self.oBase.redisplay_categories()
            self.display()
        dialog.destroy()    

    def get_selected(self):
        (model, iter) = self.treeSelection.get_selected()
        cat = self.listStore.get_value(iter, 0)
        return self.oBase.oConf.categories[cat]
    
    
    def edit_categories(self, data):
        cat = self.get_selected()
        dialog = gtk.Dialog("Edit Categorie",None,gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                                   (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OK, gtk.RESPONSE_OK))
        label = gtk.Label()
        entry = gtk.Entry()
        label.set_text("Name")
        entry.set_text(cat.name)
        dialog.vbox.pack_start(label,False,True,4)
        dialog.vbox.pack_start(entry,False,True,4)
        dialog.show_all()
        response = dialog.run()
        if response == gtk.RESPONSE_OK and entry.get_text() != cat.name:
            del self.oBase.oConf.categories[cat.name]
            self.oBase.oConf.add_categorie(entry.get_text())
            self.oBase.redisplay_categories()
            self.display()
        dialog.destroy()           
   
    def del_categories(self, data):
        cat = self.get_selected()
        del self.oBase.oConf.categories[cat.name]
        self.oBase.redisplay_categories()
        self.display()
        
        
        
        
        
        
        