# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk, gobject

from ogzDialogCalendar import ogzDialogCalendar

class ogzFrameCalendars:

    def __init__(self, calendars, oBase):
        self.calendars = calendars
        self.oBase = oBase
        self.frame = gtk.Frame()
        self.treeView = gtk.TreeView()
        self.listStore = gtk.ListStore(str, str, gobject.TYPE_BOOLEAN,object)
        
        self.treeView.set_model(self.listStore)
        
        celText = gtk.CellRendererText()      # on prepare la view de la liste des calendriers
        celTogg = gtk.CellRendererToggle()
        celTogg.set_property('activatable', True)
        colName = gtk.TreeViewColumn('Calendriers')
        colTogg = gtk.TreeViewColumn('Show',celTogg)
        colTogg.add_attribute(celTogg, "active", 2)
        
        colName.pack_start(celText, False)
        colName.add_attribute(celText, 'text', 1)
        self.treeView.append_column(colTogg)        
        self.treeView.append_column(colName)
        
        self.treeSelection = self.treeView.get_selection()
        
        self.frame.add(self.treeView)
        self.display()
        celTogg.connect('toggled', self.on_celTogg_toggled, self.listStore)
        self.treeView.connect('row-activated', self.on_treeView_row_activated)
    
    
    def display(self):
        self.listStore.clear()
        for cal in self.calendars.values():
            self.listStore.append([cal.filename, cal.name, True,cal])
            
    def on_celTogg_toggled(self, cell, path, model):
        print path
        model[path][2] = not model[path][2]
        self.calendars[self.listStore[int(path)][0]].selected = model[path][2]
        self.oBase.redisplay_selected_calendars()
#        self.myTaskList.display()
    
    def get_selected(self):
        (model, iter) = self.treeSelection.get_selected()
        cal = self.listStore.get_value(iter, 3)
        return cal
    
    def on_treeView_row_activated(self, treeview, path, column):
        if column == treeview.get_column(0):
            return
        row = path[0]
        print  column
        calendar = self.calendars[self.listStore[row][0]]
        dialog = ogzDialogCalendar(calendar, "edit", self.oBase.oConf)
        dialog.run()
        self.listStore[row][1] = calendar.name #update cal name
          
        
