# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk, gobject

from ogzDialogCalendar import ogzDialogCalendar
from ogzBrowse import ogzBrowseColumn,ogzBrowse
import gettext

_ = gettext.gettext

class ogzFrameCalendars:

    def __init__(self, calendars, oBase):
        self.calendars = calendars
        self.oBase = oBase
        self.frame = gtk.Frame()
        
        lisBrCols = []
        lisBrCols.append( ogzBrowseColumn( "filname", str, None, None, False ) )
        lisBrCols.append( ogzBrowseColumn( _("Show"), gobject.TYPE_BOOLEAN,None, None, True,[["toggled",self.on_celTogg_toggled]]) )
        lisBrCols.append( ogzBrowseColumn( _("Calendars"), str) )
        lisBrCols.append( ogzBrowseColumn( "calObject", object, None, None, False) )
        
        obr = ogzBrowse(lisBrCols, "list")
        self.treeView = obr.getView()
        self.listStore = self.treeView.get_model()

        
        self.treeSelection = self.treeView.get_selection()
        
        self.frame.add(self.treeView)
        self.display()
        
        self.treeView.connect('row-activated', self.on_treeView_row_activated)
    
    
    def display(self):
        self.listStore.clear()
        for cal in self.calendars.values():
            self.listStore.append([cal.filename, True,cal.name, cal])
            
    def on_celTogg_toggled(self, cell,path, model):
        model[path][1] = not model[path][1]
        self.calendars[self.listStore[int(path)][0]].selected = model[path][1]
        self.oBase.redisplay_selected_calendars()
    
    def get_selected(self):
        (model, iter) = self.treeSelection.get_selected()
        cal = self.listStore.get_value(iter, 3)
        return cal
    
    def on_treeView_row_activated(self, treeview, path, column):
        if column == treeview.get_column(0):
            return
        row = path[0]
        print  column
        calendar = self.calendars[self.listStore[row][0]]
        dialog = ogzDialogCalendar(calendar, "edit", self.oBase.oConf)
        dialog.run()
        self.listStore[row][2] = calendar.name #update cal name
          
        
