# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk, gobject

from datetime import datetime
from icalendar import cal
#import ogzUtilsTasks

OGZ_ID_COL_CAL = 0
OGZ_ID_COL_COMPO = 1

class ogzFrameEvents:
    def __init__(self, calendars, oBase):
        self.dCalendar = calendars
        self.oBase = oBase
        self.hide_completed = True
        
        self.frame = gtk.Frame()
        
        self.treeStore = gtk.TreeStore( str,  object )  #   calendar filename, calendar component

        self.treeView = gtk.TreeView(self.treeStore)
       
        celSummary = gtk.CellRendererText()
        colSummary = gtk.TreeViewColumn('Name', celSummary)
        colSummary.set_cell_data_func(celSummary, self.celSummary_cb)
        colSummary.set_resizable(True)
        
        celCategorie = gtk.CellRendererText()
        colCategorie = gtk.TreeViewColumn('Categorie', celCategorie)
        colCategorie.set_cell_data_func(celCategorie, self.celCategorie_cb)
        colCategorie.set_resizable(True)
        colCategorie.set_visible(False)
        
        
        colChooseCol = gtk.TreeViewColumn('-')
        colChooseCol.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
        #colChooseCol.set_fixed_width(2)
        colChooseCol.set_clickable(True)
        colChooseCol.set_max_width(2)
        
        #colTogg.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)

        self.treeView.append_column(colSummary)
        self.treeView.append_column(colCategorie)
        self.treeView.append_column(colChooseCol)

        
        #self.treeView.enable_model_drag_source(gtk.gdk.BUTTON1_MASK	, [("toto",gtk.TARGET_SAME_WIDGET,1)], gtk.gdk.ACTION_MOVE | gtk.gdk.ACTION_DEFAULT)
        #self.treeView.enable_model_drag_dest([("toto",gtk.TARGET_SAME_WIDGET,1)], gtk.gdk.ACTION_MOVE | gtk.gdk.ACTION_DEFAULT)
        self.treeView.set_reorderable(True)
        

        self.treeselection = self.treeView.get_selection()

        self.scrolledwindow = gtk.ScrolledWindow(None, None)
        self.scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        self.scrolledwindow.add(self.treeView)
        self.treeView.connect("cursor-changed", self.on_task_selected)
        # right click managment
        self.treeView.add_events(gtk.gdk.BUTTON_PRESS_MASK)
        self.treeView.connect('button_press_event', self.on_treeview_button)
        
        self.treeView.connect('row-activated', self.on_treeView_row_activated)

        colChooseCol.connect("clicked", self.colChooseCol_clicked_cb)

        self.display()
        
        
        #self.checkButton = gtk.CheckButton("Hide Completed Tasks")
        #self.checkButton.set_active(self.hide_completed)
        #self.checkButton.connect("clicked", self.on_checkButton_clicked)
        self.vBox = gtk.VBox(homogeneous=False, spacing=0)
        #self.vBox.pack_start(child=self.checkButton ,expand=False, fill=False, padding=4)
        self.vBox.pack_start(child=self.scrolledwindow ,expand=True, fill=True, padding=2)
        self.frame.add(self.vBox)
        self.frame.show_all()
        
    def display(self):
         self.treeStore.clear()
         for dcal in self.dCalendar:
            ocal = self.dCalendar[dcal]
            if ocal.selected == True:
                for event in ocal.cal.walk('VEVENT'):
            
                    #eventrow = ogzUtilsTasks.correctICalTodo(event)  
                    #
                    eventrow = event
                        
                    #if (not self.hide_completed or taskrow["STATUS"] != "COMPLETED") and cat.visible:
                        #resum = taskrow["SUMMARY"]
                        #if taskrow["STATUS"] == "COMPLETED":  
                        #    resum = '<s>' + resum + '</s>' 
                        #else:
                        #    if todo.has_key('PRIORITY') and todo.decoded('priority') < 3:
                        #        resum = '<b>' + resum + '</b>'
                        #    if todo.has_key('due') and todo.decoded('due') < datetime.today():
                        #        resum ='<span foreground="red">' + resum + '</span>'
                            
                        #self.treeStore.append(None,[ocal.nbTasks, resum, dcal, taskrow["STATUS"] == "COMPLETED",todo])
                    self.treeStore.append(None,[dcal, event])
                  
                    
    def on_task_selected(self, widget):
        compo, cal = self.get_selected()
        self.oBase.preview_selected_element(compo)

    def get_selected(self):
        (model, iter) = self.treeselection.get_selected()
        compo = self.treeStore.get_value(iter, OGZ_ID_COL_COMPO)
        cal = self.treeStore.get_value(iter, OGZ_ID_COL_CAL)
        return compo, self.dCalendar[cal]
    
    def append(self,task,ocal):
        if ocal.selected == True:
            iter = self.treeStore.append(None, [ocal.filename, task])
            self.treeView.set_cursor(self.treeStore.get_path(iter))
            #ocal.nbTasks += 1
    
    def on_treeView_row_activated(self, treeview, path, column):
        if column == treeview.get_column(0): 
            return   # no activation on toggle button
        #row = model[path][OGZ_ID_COL_COMPO]
        self.oBase.edit_selected_task("")
    
        
    def on_treeview_button(self,widget, event):
        if event.button == 1 and event.type == gtk.gdk._2BUTTON_PRESS:
            print "double click gauche"
        if event.button == 3:
            print "click droit"
            
    def on_header_clicked(self, widget,data):
        print "header is clicked"
        
    
    def celSummary_cb(self, column, cell_renderer, tree_model, iter):
        compo = tree_model.get_value(iter, OGZ_ID_COL_COMPO)
        summary = compo['summary']
        #if compo["STATUS"] == "COMPLETED":  
        #    summary = '<s>' + summary + '</s>' 
        #else:
        #    if compo.decoded("PRIORITY") < 3:
        #        summary = '<b>' + summary + '</b>'   
        #    if compo.has_key('due') and compo.decoded('due') < datetime.today():
        #        summary ='<span foreground="red">' + summary + '</span>'
        cell_renderer.set_property("markup", summary)
        
    
    def celCategorie_cb(self,column, cell_renderer, tree_model, iter):
        compo = tree_model.get_value(iter, OGZ_ID_COL_COMPO)
        if compo.has_key('categories'):
            categ = compo['categories']
        else:
            categ = ''    
        cell_renderer.set_property("text", categ)     
        
        
    def colChooseCol_clicked_cb(self, column):
        print "clic clic"
        popmenu = gtk.Menu()
        menu_item = gtk.MenuItem("Choose Columns")
        menu_item.set_state(gtk.STATE_INSENSITIVE)
        menu_item.show()
        popmenu.append(menu_item)  
        for c in self.treeView.get_columns():
            if c <> column:
                menu_item = gtk.CheckMenuItem(c.get_title())
                if c.get_visible():
                    menu_item.set_active(True)
                menu_item.connect('activate', self.popupChooseCol_activated_cb, c)
                menu_item.show()
                popmenu.append(menu_item)
        popmenu.popup(None, None, None, 0, 1)        

    def popupChooseCol_activated_cb(self, menuitem, column):
        if menuitem.get_active():
            column.set_visible(True)
        else:
            column.set_visible(False)
    
