# -*- coding: iso-8859-15 -*-

import pygtk
pygtk.require('2.0')
import gtk, gobject

from datetime import datetime
from string import *
from icalendar import cal
import ogzUtilsTasks

OGZ_ID_COL_CAL = 1
OGZ_ID_COL_TOG = 2
OGZ_ID_COL_COMPO = 3

class ogzFrameTasks:
    def __init__(self, calendars, oBase):
        self.dCalendar = calendars
        self.oBase = oBase
        self.hide_completed = True
        
        self.frame = gtk.Frame()
        
        self.treeStore = gtk.TreeStore(int, str, gobject.TYPE_BOOLEAN, object )  #  task index by calendar,  calendar filename, check box,calendar component

        self.treeView = gtk.TreeView(self.treeStore)
       
        celSummary = gtk.CellRendererText()
        colSummary = gtk.TreeViewColumn('Name', celSummary)
        colSummary.set_cell_data_func(celSummary, self.celSummary_cb)
        colSummary.set_resizable(True)
        colSummary.set_expand(True)
        colSummary.set_reorderable(True)
        
        celCategorie = gtk.CellRendererText()
        colCategorie = gtk.TreeViewColumn('Categorie', celCategorie)
        colCategorie.set_cell_data_func(celCategorie, self.celCategorie_cb)
        colCategorie.set_resizable(True)
        colCategorie.set_visible(False)
        #colCategorie.set_expand(True)
        
        celPercent = gtk.CellRendererText()
        colPercent = gtk.TreeViewColumn('Percent', celPercent)
        colPercent.set_cell_data_func(celPercent, self.celPercent_cb)
        colPercent.set_resizable(True)
        colPercent.set_visible(False)
        
        #colSummary.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
        
        celDue = gtk.CellRendererText()
        colDue = gtk.TreeViewColumn('Due', celDue)
        colDue.set_cell_data_func(celDue, self.celDue_cb)
        #colDue.set_expand(True)
        colDue.set_reorderable(True)
        
        celCreated = gtk.CellRendererText()
        colCreated = gtk.TreeViewColumn('Created', celCreated)
        colCreated.set_cell_data_func(celCreated, self.celCreated_cb)
        #colDue.set_expand(True)
        colCreated.set_reorderable(True)
        
        celDtstart = gtk.CellRendererText()
        colDtstart = gtk.TreeViewColumn('Dtstart', celDtstart)
        colDtstart.set_cell_data_func(celDtstart, self.celStart_cb)
        #colDue.set_expand(True)
        colDtstart.set_reorderable(True)
        
        
        colChooseCol = gtk.TreeViewColumn('-')
        colChooseCol.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
        colChooseCol.set_fixed_width(20)
        colChooseCol.set_clickable(True)
        colChooseCol.set_max_width(20)
        colChooseCol.set_expand(False)
        
        celTogg = gtk.CellRendererToggle()
        celTogg.set_property('activatable', True)
        colTogg = gtk.TreeViewColumn('Done',celTogg)
        colTogg.add_attribute(celTogg, "active", OGZ_ID_COL_TOG)
        #colTogg.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)
        self.treeView.append_column(colTogg)
        self.treeView.append_column(colSummary)
        self.treeView.append_column(colDtstart)
        self.treeView.append_column(colDue)
        self.treeView.append_column(colCreated)
        
        self.treeView.append_column(colCategorie)
        self.treeView.append_column(colPercent)        
        
        self.treeView.append_column(colChooseCol)

  
        
        #self.treeView.enable_model_drag_source(gtk.gdk.BUTTON1_MASK	, [("toto",gtk.TARGET_SAME_WIDGET,1)], gtk.gdk.ACTION_MOVE | gtk.gdk.ACTION_DEFAULT)
        #self.treeView.enable_model_drag_dest([("toto",gtk.TARGET_SAME_WIDGET,1)], gtk.gdk.ACTION_MOVE | gtk.gdk.ACTION_DEFAULT)
        self.treeView.set_reorderable(True)
       
	TARGETS = [ ('MY_TREE_MODEL_ROW', gtk.TARGET_SAME_WIDGET, 0)]

	#self.treeView.enable_model_drag_source( gtk.gdk.BUTTON1_MASK,
              #                                  TARGETS,
                #                                gtk.gdk.ACTION_DEFAULT| gtk.gdk.ACTION_MOVE|gtk.gdk.ACTION_LINK)
        #self.treeView.enable_model_drag_dest( TARGETS,
                   #                          gtk.gdk.ACTION_DEFAULT | gtk.gdk.ACTION_LINK)


        self.treeselection = self.treeView.get_selection()

        self.scrolledwindow = gtk.ScrolledWindow(None, None)
        self.scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        self.scrolledwindow.add(self.treeView)
        self.treeView.connect("cursor-changed", self.on_task_selected)
        # right click managment
        self.treeView.add_events(gtk.gdk.BUTTON_PRESS_MASK)
        self.treeView.connect('button_press_event', self.on_treeview_button)
        
        celTogg.connect('toggled', self.on_celTogg_toggled, self.treeStore)
        self.treeView.connect('row-activated', self.on_treeView_row_activated)
        self.treeView.connect("drag-data-get", self.drag_data_get_cb)
        self.treeView.connect("drag-data-received", self.drag_data_received_cb)
        self.treeView.connect("drag-end", self.drag_end_cb)
        colChooseCol.connect("clicked", self.colChooseCol_clicked_cb)


        
        self.checkButton = gtk.CheckButton("Hide Completed Tasks")
        self.checkButton.set_active(self.hide_completed)
        self.checkButton.connect("clicked", self.on_checkButton_clicked)
        searchLabel = gtk.Label()
        searchLabel.set_text("Search")
        self.searchEntry = gtk.Entry()
        self.searchEntry.connect("changed", self.on_searchEntry_changed)
        hbox = gtk.HBox(homogeneous=False, spacing=0)
        hbox.pack_start(child=self.checkButton ,expand=False, fill=False, padding=4)
        hbox.pack_start(child=searchLabel ,expand=True, fill=True, padding=4)
        hbox.pack_start(child=self.searchEntry ,expand=True, fill=False, padding=4)
        self.vBox = gtk.VBox(homogeneous=False, spacing=0)
        self.vBox.pack_start(child=hbox ,expand=False, fill=False, padding=4)
        self.vBox.pack_start(child=self.scrolledwindow ,expand=True, fill=True, padding=30)
        
        self.display()
        
        self.frame.add(self.vBox)
        self.frame.show_all()
        
        
    def display(self):
         self.treeStore.clear()
         for dcal in self.dCalendar:
            ocal = self.dCalendar[dcal]
            ocal.nbTasks = 0
            if ocal.selected == True:
                for todo in ocal.cal.walk('VTODO'):
            
                    taskrow = ogzUtilsTasks.correctICalTodo(todo)  
                    try:
                        cat = self.oBase.oConf.categories[taskrow["CATEGORIES"]]
                    except KeyError:
                        cat = self.oBase.oConf.add_categorie(taskrow["CATEGORIES"])
                    
                    if (not self.hide_completed or taskrow["STATUS"] != "COMPLETED") and cat.visible:
                        #resum = taskrow["SUMMARY"]
                        #if taskrow["STATUS"] == "COMPLETED":  
                        #    resum = '<s>' + resum + '</s>' 
                        #else:
                        #    if todo.has_key('PRIORITY') and todo.decoded('priority') < 3:
                        #        resum = '<b>' + resum + '</b>'
                        #    if todo.has_key('due') and todo.decoded('due') < datetime.today():
                        #        resum ='<span foreground="red">' + resum + '</span>'
                            
                        #self.treeStore.append(None,[ocal.nbTasks, resum, dcal, taskrow["STATUS"] == "COMPLETED",todo])
                        s = upper(strip(self.searchEntry.get_text()))
                        if find(upper(taskrow['SUMMARY']), s) >= 0 or find(upper(taskrow['DESCRIPTION']), s) >= 0:
                            self.treeStore.append(None,[ocal.nbTasks, dcal, taskrow["STATUS"] == "COMPLETED",todo])
                        #ocal.nbTasks += 1 
                for row in self.treeStore:
                    compo = row[OGZ_ID_COL_COMPO]
                    #if compo.has_key('related-to'):
                        
                        
                
    def on_task_selected(self, widget):
        compo, cal = self.get_selected()
        self.oBase.preview_selected_element(compo)

    def get_selected(self):
        (model, iter) = self.treeselection.get_selected()
        compo = self.treeStore.get_value(iter, OGZ_ID_COL_COMPO)
        cal = self.treeStore.get_value(iter, OGZ_ID_COL_CAL)
        return compo, self.dCalendar[cal]
    
    def append(self,task,ocal):
        if ocal.selected == True:
            iter = self.treeStore.append(None, [ocal.nbTasks, ocal.filename, ocal.selected, task])
            self.treeView.set_cursor(self.treeStore.get_path(iter))
            #ocal.nbTasks += 1
    
    def on_treeView_row_activated(self, treeview, path, column):
        if column == treeview.get_column(0): 
            return   # no activation on toggle button
        #row = model[path][OGZ_ID_COL_COMPO]
        self.oBase.edit_selected_task("")
    
    def on_searchEntry_changed(self, widget):
        self.display()
        
    def on_celTogg_toggled(self, cell, path, model):
        print cell,path,model
        model[path][OGZ_ID_COL_TOG] = not model[path][OGZ_ID_COL_TOG]
        todo = model[path][OGZ_ID_COL_COMPO]
        if todo["STATUS"] == "COMPLETED":
            todo["STATUS"] = "NEEDS-ACTION"
            #if todo["PRIORITY"] < '3':
             #   model[path][1] = '<b>' + todo['SUMMARY'] + '</b>' 
        else:
            todo["STATUS"] = "COMPLETED"
            #model[path][1] = '<s>' + todo['SUMMARY'] + '</s>' 
    #    self.calendars[self.listStore[int(path)][0]].selected = model[path][2]
    #    self.display()
    def on_checkButton_clicked(self, widget):
        self.hide_completed = widget.get_active()
        self.display()
        
    def on_treeview_button(self,widget, event):
        if event.button == 1 and event.type == gtk.gdk._2BUTTON_PRESS:
            print "double click gauche"
        if event.button == 3:
            print "click droit"
            self.context_menu(event)
            
    def context_menu(self,event):
        entries =[ 
        (gtk.STOCK_EDIT, self.oBase.edit_selected_task, True),
        (gtk.STOCK_PRINT, None, False),
        (gtk.STOCK_DELETE, None, False)  ]

        menu = gtk.Menu()
        smenu = gtk.Menu()        
        
        item = gtk.ImageMenuItem(gtk.STOCK_EDIT)
        item.connect("activate",self.oBase.edit_selected_task)
        menu.append(item)
        
        menu.append(gtk.SeparatorMenuItem())
        
        
        item = gtk.ImageMenuItem('Make Post-it')
        i = gtk.Image()
        i.set_from_stock(gtk.STOCK_PREFERENCES,gtk.ICON_SIZE_MENU) 
        item.set_image(i)
        item.connect("activate",self.oBase.make_postit)
        menu.append(item)
        
        menu.append(gtk.SeparatorMenuItem())
        
        
        item = gtk.ImageMenuItem(gtk.STOCK_PRINT)
        menu.append(item)
        
        menu.append(gtk.SeparatorMenuItem())
        
        item = gtk.ImageMenuItem(gtk.STOCK_DELETE)
        item.set_submenu(smenu)
        menu.append(item)
        
        item = gtk.ImageMenuItem(gtk.STOCK_DELETE)
        item.connect("activate",self.oBase.delete_selected_task)
        smenu.append(item)
        
        menu.append(gtk.SeparatorMenuItem())
        
        smenu2 = gtk.Menu()
        item = gtk.ImageMenuItem(gtk.STOCK_NEW)
        item.set_submenu(smenu2)
        menu.append(item)
        
        item = gtk.ImageMenuItem(gtk.STOCK_ADD)
        item.connect("activate",self.oBase.add_new_task)
        smenu2.append(item)
        
        
        
        menu.show_all()

        #for stock_id,callback,sensitivity in entries:
        #    item = gtk.ImageMenuItem(stock_id)
        #    if callback:
        #        item.connect("activate",callback)
        #    item.set_sensitive(sensitivity)
        #    item.show()
        #    menu.append(item)
            
        menu.popup(None,None,None,event.button,event.time) 
            
    def on_header_clicked(self, widget,data):
        print "header is clicked"
        
    def drag_data_received_cb(self, treeview, context, x, y, selection,
                                info, etime):
        print "data_received", context, x, y, selection, info, etime
        model = treeview.get_model()
        data = selection.data
        
        #print "data =",data, "info=", info
        #print "ici : ", selection.get_text()
        drag_dest = self.treeView.get_drag_dest_row()
        if drag_dest != None:
        #    print selection.type, selection.get_text(), str(selection.data)
            #print selection
            drop_pos = drag_dest[1]
            if drop_pos != None:
                print "on drag vers", drag_dest[0]
        #drop_info = treeview.get_dest_row_at_pos(x, y)
        #if drop_info:
        #    path_dest, position = drop_info
        #    iter = model.get_iter(path_dest)
	#    print path_dest, position
            #if (position == gtk.TREE_VIEW_DROP_BEFORE
             #   or position == gtk.TREE_VIEW_DROP_INTO_OR_BEFORE):
              #  model.insert_before(iter, [data])
            #else:
             #   model.insert_after(iter, [data])
        #else:
            #model.append([data])
       #       pass
        #if context.action == gtk.gdk.ACTION_MOVE:
        #    context.finish(True, True, etime)
        
        
    def drag_end_cb(self, widget, context):
        #print "drag-end", "widget=",widget, " context=", context
        #print "selection", context.drag_get_selection()
        #print self.treeView.get_drag_dest_row()
        self.treeView.expand_all()
        
    def drag_data_get_cb(self,treeview, context, selection, info, timestamp):
        print "drag_data_get", selection, info, context,timestamp
	#print "dest=", treeview.get_drag_dest_row()
        treeselection = treeview.get_selection()
        model, iter = treeselection.get_selected()
        dragged_compo = model.get_value(iter, OGZ_ID_COL_COMPO)
        #print dragged_compo['summary']
        selection.set("toto", 1, str(dragged_compo))
        
    
    def celSummary_cb(self, column, cell_renderer, tree_model, iter):
        compo = tree_model.get_value(iter, OGZ_ID_COL_COMPO)
        summary = compo['summary']
        if compo["STATUS"] == "COMPLETED":  
            summary = '<s>' + summary + '</s>' 
        else:
            if compo.decoded("PRIORITY") < 2:
                summary = '<span weight="bold" background="#FFC055">' + summary + '</span>'   
            elif compo.decoded("PRIORITY") < 4:
                summary = '<span background="#FFF099">' + summary + '</span>'   
            elif compo.decoded("PRIORITY") > 8:
                summary = '<span foreground="#ABABAB">' + summary + '</span>' 
            elif compo.decoded("PRIORITY") > 6:
                summary = '<span foreground="#6A6A6A">' + summary + '</span>'

                          
            if compo.has_key('due') and compo.decoded('due') < datetime.today():
                summary ='<span foreground="red">' + summary + '</span>'
        cell_renderer.set_property("markup", summary)
        
    def celDue_cb(self, column, cell_renderer, tree_model, iter):
        compo = tree_model.get_value(iter, OGZ_ID_COL_COMPO)
        if compo.has_key('due'):
            due = compo.decoded('due').strftime("%d/%m/%Y")
        else:
            due = ''    
        cell_renderer.set_property("text", due)        
        
    def celStart_cb(self, column, cell_renderer, tree_model, iter):
        compo = tree_model.get_value(iter, OGZ_ID_COL_COMPO)
        if compo.has_key('dtstart'):
            dts = compo.decoded('dtstart').strftime("%d/%m/%Y")
        else:
            dts = ''    
        cell_renderer.set_property("text", dts)                
        
    def celCreated_cb(self, column, cell_renderer, tree_model, iter):
        compo = tree_model.get_value(iter, OGZ_ID_COL_COMPO)
        if compo.has_key('created'):
            cre = compo.decoded('created').strftime("%d/%m/%Y")
        else:
            cre = ''    
        cell_renderer.set_property("text", cre)                
    
    def celCategorie_cb(self,column, cell_renderer, tree_model, iter):
        compo = tree_model.get_value(iter, OGZ_ID_COL_COMPO)
        if compo.has_key('categories'):
            categ = compo['categories']
        else:
            categ = ''    
        cell_renderer.set_property("text", categ)     
        
    def celPercent_cb(self,column, cell_renderer, tree_model, iter):
        compo = tree_model.get_value(iter, OGZ_ID_COL_COMPO)
        if compo.has_key('percent-complete'):
            pcent = compo['percent-complete']
        else:
            pcent = ''    
        cell_renderer.set_property("text", pcent)             
        
    def colChooseCol_clicked_cb(self, column):
        print "clic clic clic"
        popmenu = gtk.Menu()
        menu_item = gtk.MenuItem("Choose Columns")
        menu_item.set_state(gtk.STATE_INSENSITIVE)
        menu_item.show()
        popmenu.append(menu_item)  
        for c in self.treeView.get_columns():
            if c <> column:
                menu_item = gtk.CheckMenuItem(c.get_title())
                if c.get_visible():
                    menu_item.set_active(True)
                menu_item.connect('activate', self.popupChooseCol_activated_cb, c)
                menu_item.show()
                popmenu.append(menu_item)
        popmenu.show()
        popmenu.popup(None, None, None, gtk.gdk.LEFTBUTTON, 0)       #Warning mouse button number  may change according OS

    def popupChooseCol_activated_cb(self, menuitem, column):
        if menuitem.get_active():
            column.set_visible(True)
        else:
            column.set_visible(False)
    def on_printButton_clicked(self, widget):
        for dcal in self.dCalendar:
            ocal = self.dCalendar[dcal]
            if ocal.selected == True:
                for todo in ocal.cal.walk('VTODO'):
                    cat = self.oBase.oConf.categories[todo["CATEGORIES"]]
                    if (not self.hide_completed or todo["STATUS"] != "COMPLETED") and cat.visible:
                        print todo["summary"], '\n'
                        print todo["description"], '\n\n-------------\n\n'
                        
                    
                    
